
import os
import socket
import platform


def local_ipv4():
    # получаем локальный IP-адрес с помощью широковещательной рассылки
    st = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    try:
        st.connect(('10.255.255.255', 1))
        ip_l = st.getsockname()[0]
    except Exception:
        ip_l = '127.0.0.1'
    finally:
        st.close()
    return ip_l


def home_server_start():
    home_server = socket.create_server((local_ipv4(), 2050))
    home_server.listen(4)
    while True:
        print('Весь в работе...\n')
        client, address = home_server.accept()
        content = client.recv(1024).decode('utf-8')
        print(content)

        send_data = reciever_home_server(content)
        client.send(send_data)
        client.shutdown(socket.SHUT_WR)


def reciever_home_server(request_data):
    headers = 'HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=utf-8\r\n\r\n'
    headers_404 = 'HTTP/1.1 404 OK\r\nContent-Type: text/html; charset=utf-8\r\n\r\n '
    headers_403 = 'HTTP/1.1 403 OK\r\nContent-Type: text/html; charset=utf-8\r\n\r\n '
    path = request_data.split(" ")[1]
    if path == '/ls':
        if platform.system() == "Linux":
            respons = str(os.listdir(os.environ['HOME'])).encode('utf-8')
            return headers.encode('utf-8') + respons
        elif platform.system() == "Windows":
            respons = str(os.listdir(os.path.join(os.environ['USERPROFILE'], 'Documents'))).encode('utf-8')
            return headers.encode('utf-8') + respons
    elif path == "/platform":
        respons = f'ОС: {platform.system()} <p>Версия: {platform.version()}</p>' \
                  f'<p>Архитектура: {platform.machine()}</p>'.encode('utf-8')
        return headers.encode('utf-8') + respons
    elif path == "/favicon.ico":
        respons = 'rel="shortcut icon" href="#"'.encode('utf-8')
        return headers.encode('utf-8') + respons
    else:
        return (headers_404 + 'Извиняйте, но этой страницы нет').encode('utf-8')


if __name__ == "__main__":
    home_server_start()
